﻿const { refObject, Button, ImageButton, TextBox, Vector, world } = require('@tabletop-playground/api');
const { ChangeImageSlider, PositionsFontUI } = require('./general/General_Functions.js');
//-----------------------------------------------------------------
const zPosition = 0.05;
//-----------------------------------------------------------------
class ExperienceBox {
  startImageSliderPosX = 9.9;
  firstTime = true;
  fontUI = new UIElement();
  //-------------------------
  constructor(parent, position) {
    this.parent = parent;
    this.Ex = 0;
    this.maxEx = 50;
    //-------------------------
    this.box = new Button();
    this.changeExValue = 1;
    this.box.setFontSize(24);

    let boxUI = new UIElement();
    boxUI.position = position;
    boxUI.rotation = new Rotator(0, 0, 180);
    boxUI.widget = this.box;
    boxUI.scale = 0.2;
    parent.attachUI(boxUI);
    //-------------------------
    position = position.add(new Vector(1.79, -6.3, 0));
    this.startPosition = position;
    //-------------------------
    this.decrement = new ImageButton().setImage("minus.png");
    this.decrement.setImageSize(50);

    let decUI = new UIElement();
    decUI.position = position.add(new Vector(0, 10.35, 0));
    decUI.widget = this.decrement;
    decUI.scale = 0.1;
    parent.attachUI(decUI);
    //-------------------------
    this.increment = new ImageButton().setImage("plus.png");
    this.increment.setImageSize(50);

    let incUI = new UIElement();
    incUI.position = position.add(new Vector(0, -4.35, 0));
    incUI.widget = this.increment;
    incUI.scale = 0.1;
    parent.attachUI(incUI);
    //-------------------------
    this.back = new ImageWidget().setImage("bar1.png");

    let backUI = new UIElement();
    backUI.useWidgetSize = false;
    backUI.width = 1400;
    backUI.height = 58;
    backUI.position = position.add(new Vector(0, 3, -0.01));
    backUI.rotation = new Rotator(0, 0, 180);
    backUI.widget = this.back;
    backUI.scale = 0.1;
    parent.attachUI(backUI);
    //-------------------------
    this.font = new ImageWidget().setImage("barline1.png");

    let procent = (100 * this.Ex) / this.maxEx;
    this.fontUI.useWidgetSize = false;
    this.fontUI.width = procent * 14;
    this.fontUI.height = 58;
    this.fontUI.position = position.add(new Vector(0, PositionsFontUI(this.startImageSliderPosX, this.fontUI.width), 0));
    this.fontUI.rotation = new Rotator(0, 0, 180);
    this.fontUI.widget = this.font;
    this.fontUI.scale = 0.1;
    parent.attachUI(this.fontUI);
    //-------------------------
    this.fontText = new TextBox().setText(this.Ex + "/" + this.maxEx).setEnabled(false);
    this.fontText.setFontSize(18);

    let fountTextUI = new UIElement();
    fountTextUI.position = backUI.position.add(new Vector(0, 0, 0.02));
    fountTextUI.rotation = new Rotator(0, 0, 180);
    fountTextUI.widget = this.fontText;
    fountTextUI.scale = 0.2;
    parent.attachUI(fountTextUI);
    //-------------------------
    let t = this;
    let boxTable = [1, 5, 10, 25, 50, 100];
    let boxIndex = 0;
    this.box.onClicked.add(function () {
      boxIndex++;
      if (boxIndex >= boxTable.length) {
        boxIndex = 0;
      }
      t.changeExValue = boxTable[boxIndex];
    });
    this.decrement.onClicked.add(function () {
      t.Ex -= t.changeExValue;
      if (t.Ex < 0) {
        t.Ex = 0;
      }
      ChangeImageSlider(
        t.fontUI, t.Ex, t.maxEx, t.startPosition, t.fontText, t.parent, t.startImageSliderPosX, null, 14);
      if (!t.firstTime) saveState(); else t.firstTime = false;
    });
    this.increment.onClicked.add(function () {
      t.value += t.changeExValue;
      ChangeImageSlider(
        t.fontUI, t.Ex, t.maxEx, t.startPosition, t.fontText, t.parent, t.startImageSliderPosX, null, 14);
      if (!t.firstTime) saveState(); else t.firstTime = false;
    });
  }

  get changeExValue() { return parseInt(this.box.getText()); }
  set changeExValue(number) { this.box.setText(number.toString()); }

  get value() { return this.Ex; }
  set value(number) {
    this.Ex = number;
    if (this.Ex >= this.maxEx) {
      this.Ex -= this.maxEx;
      level.value = level.value + 1;
    }
    ChangeImageSlider(
      this.fontUI, this.Ex, this.maxEx, this.startPosition, this.fontText, this.parent, this.startImageSliderPosX, null, 14);
  }

  SetMaxEx(value, resetEx) {
    this.Ex = !resetEx && this.Ex || 0;
    this.maxEx = value;
    ChangeImageSlider(
      this.fontUI, this.Ex, this.maxEx, this.startPosition, this.fontText, this.parent, this.startImageSliderPosX, null, 14);
  }
}
let experience = new ExperienceBox(refObject, new Vector(-0.2, 3.3, zPosition));

class LevelBox {
  constructor(parent, position) {
    this.parent = parent;
    //-------------------------
    this.box = new TextBox().setInputType(4).setMaxLength(3).setText("1");
    this.box.setEnabled(false);
    this.box.setFontSize(24);
    this.value = 1;

    let boxUI = new UIElement();
    boxUI.position = position;
    boxUI.rotation = new Rotator(0, 0, 180);
    boxUI.scale = 0.2;
    boxUI.widget = this.box;
    parent.attachUI(boxUI);
    //-------------------------
    this.decrement = new ImageButton().setImage("minus.png");
    this.decrement.setImageSize(50);

    let decUI = new UIElement();
    decUI.position = position.add(new Vector(0, 0.85, 0));
    decUI.widget = this.decrement;
    decUI.scale = 0.1;
    parent.attachUI(decUI);
    //-------------------------
    this.increment = new ImageButton().setImage("plus.png");
    this.increment.setImageSize(50);

    let incUI = new UIElement();
    incUI.position = position.add(new Vector(0, -0.85, 0));
    incUI.widget = this.increment;
    incUI.scale = 0.1;
    parent.attachUI(incUI);
    //-------------------------
    let t = this
    this.decrement.onClicked.add(function () {
      if (t.value > 1) {
        t.value -= 1;
        saveState();
      }
    });
    this.increment.onClicked.add(function () {
      t.value += 1;
      saveState();
    });
  }

  get value() { return parseInt(this.box.getText()); }
  set value(number) {
    experience.SetMaxEx(50 * number, parseInt(this.box.getText()) > number);
    this.box.setText(number.toString());
  }
}
let level = new LevelBox(refObject, new Vector(-1.2, 3.3, zPosition));

class ResetLevel {
  constructor(parent, position) {
    this.parent = parent;
    //-------------------------
    this.reset = new ImageButton().setImage("resetl1.png");
    this.reset.setImageSize(200);

    let resetUI = new UIElement();
    resetUI.position = position;
    resetUI.rotation = new Rotator(0, 0, 180);
    resetUI.widget = this.reset;
    resetUI.scale = 0.1;
    parent.attachUI(resetUI);
    //-------------------------
    this.reset.onClicked.add((obj, player) => {
      level.value = 1;
      experience.value = 0;
      let allObject = world.getAllObjects();
      for (let i = 0; i < allObject.length; i++) {
        //world.broadcastChatMessage(allObject[i].getName() + ":" + i);
        if (refObject != allObject[i] && refObject.getName() == allObject[i].getName()) {
          allObject[i].ResetValue();
        }
      }
    })
  }
}
let reset = new ResetLevel(refObject, new Vector(-1.35, -6.86, zPosition));
//-----------------------------------------------------------------
function saveState() {
  let state = {};

  state["level"] = level.value;
  state["experience"] = experience.value;

  refObject.setSavedData(JSON.stringify(state));
}

function loadState() {
  if (refObject.getSavedData() === "") {
    saveState();
    return;
  }

  let state = JSON.parse(refObject.getSavedData());

  level.value = state["level"];
  experience.value = state["experience"];
}
//-----------------------------------------------------------------
loadState();