const { Vector, world } = require('@tabletop-playground/api');

let changerObjects = []
function SetValueChars(value, type, array) {
  for (let i = 0; i < changerObjects.length; i++) {
    if (type == "")
      world.getObjectById(changerObjects[i]).RecalculationMain(array);
    else
      world.getObjectById(changerObjects[i]).RecalculationMain(type, value, changerObjects);
  }
}
function SetIdObject(id) {
  changerObjects.push(id);
}

const TypeShow = {
  STANDART: 0,
  PROCENT: 1,
}

function PositionsFontUI(startX, i) { return startX - 0.005 * i; }

function ChangeImageSlider(image, value, maxValue, position, text, parent, startX, type, multiply) {
  type = type || TypeShow.STANDART;
  multiply = multiply || 10;
  let procent = (100 * value) / maxValue;
  image.width = procent * multiply;
  image.position = position.add(new Vector(0, PositionsFontUI(startX, image.width), 0));
  if (TypeShow.STANDART == type)
    text.setText(value + "/" + maxValue);
  else if (TypeShow.PROCENT == type)
    text.setText(procent + "%");
  parent.updateUI(image);
}

module.exports.ChangeImageSlider = ChangeImageSlider;
module.exports.PositionsFontUI = PositionsFontUI;
module.exports.TypeShow = TypeShow;
module.exports.SetValueChars = SetValueChars;
module.exports.SetIdObject = SetIdObject;